My Project: Entity Class Reference

My Project

Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Entity Class Referenceabstract

`#include <entity.h>`

Inheritance diagram for Entity:

## Public Member Functions

| Entity ()
virtual Entity * | CopyEntity (Entity *ent)=0
virtual void | FreeEntity (void)
void | EntityParent (Entity *parent_ent, int glob=true)
Entity * | GetParent ()
int | CountChildren ()
Entity * | GetChild (int child_no)
Entity * | FindChild (string child_name)
int | CountAllChildren (int no_children=0)
Entity * | GetChildFromAll (int child_no, int &no_children, Entity *ent=NULL)
void | UpdateAllEntities (void(Update)(Entity *ent, Entity *ent2), Entity *ent2=NULL)
void | PositionEntity (float x, float y, float z, int glob=false)
void | MoveEntity (float mx, float my, float mz)
void | TranslateEntity (float tx, float ty, float tz, int glob=false)
void | ScaleEntity (float x, float y, float z, int glob=false)
void | RotateEntity (float x, float y, float z, int glob=false)
void | TurnEntity (float x, float y, float z, int glob=false)
void | PointEntity (Entity *target_ent, float roll=0.0)
float | EntityX (int global=false)
float | EntityY (int global=false)
float | EntityZ (int global=false)
float | EntityYaw (int global=false)
float | EntityPitch (int global=false)
float | EntityRoll (int global=false)
float | EntityScaleX (int glob=false)
float | EntityScaleY (int glob=false)
float | EntityScaleZ (int glob=false)
void | EntityColor (float r, float g, float b, float a, int recursive=false)
void | EntityColor (float r, float g, float b, int recursive=false)
void | EntityRed (float r, int recursive=false)
void | EntityGreen (float g, int recursive=false)
void | EntityBlue (float b, int recursive=false)
void | EntityAlpha (float a, int recursive=false)
void | EntityShininess (float s, int recursive=false)
void | EntityBlend (int blend_no, int recursive=false)
void | EntityFX (int fx_no, int recursive=false)
void | EntityTexture (Texture *texture, int frame=0, int index=0, int recursive=false)
void | PaintEntity (Brush &bru, int recursive=false)
Brush * | GetEntityBrush ()
void | EntityOrder (int order_no, int recursive=false)
void | ShowEntity ()
void | HideEntity ()
int | Hidden ()
void | NameEntity (string e_name)
string | EntityName ()
string | EntityClass ()
void | Animate (int mode=1, float speed=1.0, int seq=0, int trans=0)
void | SetAnimTime (float time, int seq=0)
int | AnimLength ()
float | AnimTime ()
int | ExtractAnimSeq (int first_frame, int last_frame, int seq=0)
int | LoadAnimSeq (string filename)
void | SetAnimKey (float frame, int pos_key=true, int rot_key=true, int scale_key=true)
int | AddAnimSeq (int length)
void | EntityType (int type_no, int recursive=false)
int | GetEntityType ()
void | EntityRadius (float rx, float ry=0.0)
void | EntityBox (float x, float y, float z, float w, float h, float d)
void | ResetEntity ()
Entity * | EntityCollided (int type_no)
int | CountCollisions ()
float | CollisionX (int index)
float | CollisionY (int index)
float | CollisionZ (int index)
float | CollisionNX (int index)
float | CollisionNY (int index)
float | CollisionNZ (int index)
float | CollisionTime (int index)
Entity * | CollisionEntity (int index)
Surface * | CollisionSurface (int index)
int | CollisionTriangle (int index)
void | EntityPickMode (int no, int obscure=true)
float | EntityDistance (Entity *ent2)
float | DeltaYaw (Entity *ent2)
float | DeltaPitch (Entity *ent2)
void | AlignToVector (float x, float y, float z, int axis, float rate)
void | UpdateMat (bool load_identity=false)
void | AddParent (Entity &parent_ent)
float | EntityDistanceSquared (Entity *ent2)
void | MQ_Update ()
void | MQ_GetInvMatrix (Matrix &mat0)
void | MQ_GetMatrix (Matrix &mat3)
void | MQ_SetMatrix (Matrix &inputMatrix)
void | MQ_GetScaleXYZ (float &width, float &height, float &depth)
void | MQ_Turn (float ang, float vx, float vy, float vz, int glob=false)
virtual void | Update ()
virtual void | Render ()

## Static Public Member Functions

static void | TFormPoint (float x, float y, float z, Entity *src_ent, Entity *dest_ent)
static void | TFormVector (float x, float y, float z, Entity *src_ent, Entity *dest_ent)
static void | TFormNormal (float x, float y, float z, Entity *src_ent, Entity *dest_ent)
static float | TFormedX ()
static float | TFormedY ()
static float | TFormedZ ()
static void | UpdateChildren (Entity *ent_p)

## Public Attributes

list< Entity * > | child_list
Entity * | parent
Matrix | mat
Matrix | rotmat
float | px
float | py
float | pz
float | sx
float | sy
float | sz
float | rx
float | ry
float | rz
float | qw
float | qx
float | qy
float | qz
Brush | brush
int | order
float | alpha_order
int | hide
float | cull_radius
string | name
string | class_name
int | anim
int | anim_render
int | anim_mode
float | anim_time
float | anim_speed
int | anim_seq
int | anim_trans
int | anim_dir
vector< int > | anim_seqs_first
vector< int > | anim_seqs_last
int | no_seqs
int | anim_update
int | anim_list
int | collision_type
float | radius_x
float | radius_y
float | box_x
float | box_y
float | box_z
float | box_w
float | box_h
float | box_d
int | no_collisions
vector< CollisionImpact * > | collision
float | old_x
float | old_y
float | old_z
float | old_pitch
float | old_yaw
float | old_roll
float | new_x
float | new_y
float | new_z
int | new_no
Matrix | old_mat
int | dynamic
float | dynamic_x
float | dynamic_y
float | dynamic_z
float | dynamic_yaw
float | dynamic_pitch
float | dynamic_roll
int | pick_mode
int | obscurer

## Static Public Attributes

static list< Entity * > | entity_list
static list< Entity * > | animate_list
static float | tformed_x =0.0
static float | tformed_y =0.0
static float | tformed_z =0.0

## Constructor & Destructor Documentation

## § Entity()

Entity::Entity | ( |  | ) |

inline

## Member Function Documentation

## § AddAnimSeq()

int Entity::AddAnimSeq | ( | int | length | ) |

## § AddParent()

void Entity::AddParent | ( | Entity & | parent_ent | ) |

## § AlignToVector()

void Entity::AlignToVector | ( | float | x,
|  | float | y,
|  | float | z,
|  | int | axis = `3`,
|  | float | rate = `1`
| ) |  |

## § Animate()

void Entity::Animate | ( | int | mode = `1`,
|  | float | speed = `1.0`,
|  | int | seq = `0`,
|  | int | trans = `0`
| ) |  |

## § AnimLength()

int Entity::AnimLength | ( |  | ) |

## § AnimTime()

float Entity::AnimTime | ( |  | ) |

## § CollisionEntity()

Entity * Entity::CollisionEntity | ( | int | index | ) |

## § CollisionNX()

float Entity::CollisionNX | ( | int | index | ) |

## § CollisionNY()

float Entity::CollisionNY | ( | int | index | ) |

## § CollisionNZ()

float Entity::CollisionNZ | ( | int | index | ) |

## § CollisionSurface()

Surface * Entity::CollisionSurface | ( | int | index | ) |

## § CollisionTime()

float Entity::CollisionTime | ( | int | index | ) |

## § CollisionTriangle()

int Entity::CollisionTriangle | ( | int | index | ) |

## § CollisionX()

float Entity::CollisionX | ( | int | index | ) |

## § CollisionY()

float Entity::CollisionY | ( | int | index | ) |

## § CollisionZ()

float Entity::CollisionZ | ( | int | index | ) |

## § CopyEntity()

virtual Entity* Entity::CopyEntity | ( | Entity * | ent | ) |

pure virtual

Implemented in ParticleEmitter, FieldArray, Camera, Mesh, Blob, Light, Terrain, Bone, OcTree, Geosphere, Sprite, Pivot, and VoxelTerrain.

## § CountAllChildren()

int Entity::CountAllChildren | ( | int | no_children = `0` | ) |

## § CountChildren()

int Entity::CountChildren | ( |  | ) |

## § CountCollisions()

int Entity::CountCollisions | ( |  | ) |

## § DeltaPitch()

float Entity::DeltaPitch | ( | Entity * | ent2 | ) |

## § DeltaYaw()

float Entity::DeltaYaw | ( | Entity * | ent2 | ) |

## § EntityAlpha()

void Entity::EntityAlpha | ( | float | a,
|  | int | recursive = `false`
| ) |  |

## § EntityBlend()

void Entity::EntityBlend | ( | int | blend_no,
|  | int | recursive = `false`
| ) |  |

## § EntityBlue()

void Entity::EntityBlue | ( | float | b,
|  | int | recursive = `false`
| ) |  |

## § EntityBox()

void Entity::EntityBox | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | w,
|  | float | h,
|  | float | d
| ) |  |

## § EntityClass()

string Entity::EntityClass | ( |  | ) |

## § EntityCollided()

Entity * Entity::EntityCollided | ( | int | type_no | ) |

## § EntityColor() [1/2]

void Entity::EntityColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a,
|  | int | recursive = `false`
| ) |  |

## § EntityColor() [2/2]

void Entity::EntityColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | int | recursive = `false`
| ) |  |

## § EntityDistance()

float Entity::EntityDistance | ( | Entity * | ent2 | ) |

## § EntityDistanceSquared()

float Entity::EntityDistanceSquared | ( | Entity * | ent2 | ) |

## § EntityFX()

void Entity::EntityFX | ( | int | fx_no,
|  | int | recursive = `false`
| ) |  |

## § EntityGreen()

void Entity::EntityGreen | ( | float | g,
|  | int | recursive = `false`
| ) |  |

## § EntityName()

string Entity::EntityName | ( |  | ) |

## § EntityOrder()

void Entity::EntityOrder | ( | int | order_no,
|  | int | recursive = `false`
| ) |  |

## § EntityParent()

void Entity::EntityParent | ( | Entity * | parent_ent,
|  | int | glob = `true`
| ) |  |

## § EntityPickMode()

void Entity::EntityPickMode | ( | int | no,
|  | int | obscure = `true`
| ) |  |

## § EntityPitch()

float Entity::EntityPitch | ( | int | global = `false` | ) |

## § EntityRadius()

void Entity::EntityRadius | ( | float | rx,
|  | float | ry = `0.0`
| ) |  |

## § EntityRed()

void Entity::EntityRed | ( | float | r,
|  | int | recursive = `false`
| ) |  |

## § EntityRoll()

float Entity::EntityRoll | ( | int | global = `false` | ) |

## § EntityScaleX()

float Entity::EntityScaleX | ( | int | glob = `false` | ) |

## § EntityScaleY()

float Entity::EntityScaleY | ( | int | glob = `false` | ) |

## § EntityScaleZ()

float Entity::EntityScaleZ | ( | int | glob = `false` | ) |

## § EntityShininess()

void Entity::EntityShininess | ( | float | s,
|  | int | recursive = `false`
| ) |  |

## § EntityTexture()

void Entity::EntityTexture | ( | Texture * | texture,
|  | int | frame = `0`,
|  | int | index = `0`,
|  | int | recursive = `false`
| ) |  |

## § EntityType()

void Entity::EntityType | ( | int | type_no,
|  | int | recursive = `false`
| ) |  |

## § EntityX()

float Entity::EntityX | ( | int | global = `false` | ) |

## § EntityY()

float Entity::EntityY | ( | int | global = `false` | ) |

## § EntityYaw()

float Entity::EntityYaw | ( | int | global = `false` | ) |

## § EntityZ()

float Entity::EntityZ | ( | int | global = `false` | ) |

## § ExtractAnimSeq()

int Entity::ExtractAnimSeq | ( | int | first_frame,
|  | int | last_frame,
|  | int | seq = `0`
| ) |  |

## § FindChild()

Entity * Entity::FindChild | ( | string | child_name | ) |

## § FreeEntity()

void Entity::FreeEntity | ( | void |  | ) |

virtual

Reimplemented in ParticleEmitter, FieldArray, Camera, Mesh, Blob, Light, Sprite, Terrain, Fluid, Bone, OcTree, Geosphere, Pivot, and VoxelTerrain.

## § GetChild()

Entity * Entity::GetChild | ( | int | child_no | ) |

## § GetChildFromAll()

Entity * Entity::GetChildFromAll | ( | int | child_no,
|  | int & | no_children,
|  | Entity * | ent = `NULL`
| ) |  |

## § GetEntityBrush()

Brush * Entity::GetEntityBrush | ( |  | ) |

## § GetEntityType()

int Entity::GetEntityType | ( |  | ) |

## § GetParent()

Entity * Entity::GetParent | ( |  | ) |

## § Hidden()

int Entity::Hidden | ( |  | ) |

## § HideEntity()

void Entity::HideEntity | ( |  | ) |

## § LoadAnimSeq()

int Entity::LoadAnimSeq | ( | string | filename | ) |

## § MoveEntity()

void Entity::MoveEntity | ( | float | mx,
|  | float | my,
|  | float | mz
| ) |  |

## § MQ_GetInvMatrix()

void Entity::MQ_GetInvMatrix | ( | Matrix & | mat0 | ) |

## § MQ_GetMatrix()

void Entity::MQ_GetMatrix | ( | Matrix & | mat3 | ) |

## § MQ_GetScaleXYZ()

void Entity::MQ_GetScaleXYZ | ( | float & | width,
|  | float & | height,
|  | float & | depth
| ) |  |

## § MQ_SetMatrix()

void Entity::MQ_SetMatrix | ( | Matrix & | inputMatrix | ) |

## § MQ_Turn()

void Entity::MQ_Turn | ( | float | ang,
|  | float | vx,
|  | float | vy,
|  | float | vz,
|  | int | glob = `false`
| ) |  |

## § MQ_Update()

void Entity::MQ_Update | ( |  | ) |

## § NameEntity()

void Entity::NameEntity | ( | string | e_name | ) |

## § PaintEntity()

void Entity::PaintEntity | ( | Brush & | bru,
|  | int | recursive = `false`
| ) |  |

## § PointEntity()

void Entity::PointEntity | ( | Entity * | target_ent,
|  | float | roll = `0.0`
| ) |  |

## § PositionEntity()

void Entity::PositionEntity | ( | float | x,
|  | float | y,
|  | float | z,
|  | int | glob = `false`
| ) |  |

## § Render()

virtual void Entity::Render | ( |  | ) |

inlinevirtual

Reimplemented in Mesh, Camera, Fluid, ParticleBatch, and VoxelSprite.

## § ResetEntity()

void Entity::ResetEntity | ( |  | ) |

## § RotateEntity()

void Entity::RotateEntity | ( | float | x,
|  | float | y,
|  | float | z,
|  | int | glob = `false`
| ) |  |

## § ScaleEntity()

void Entity::ScaleEntity | ( | float | x,
|  | float | y,
|  | float | z,
|  | int | glob = `false`
| ) |  |

## § SetAnimKey()

void Entity::SetAnimKey | ( | float | frame,
|  | int | pos_key = `true`,
|  | int | rot_key = `true`,
|  | int | scale_key = `true`
| ) |  |

## § SetAnimTime()

void Entity::SetAnimTime | ( | float | time,
|  | int | seq = `0`
| ) |  |

## § ShowEntity()

void Entity::ShowEntity | ( |  | ) |

## § TFormedX()

float Entity::TFormedX | ( |  | ) |

static

## § TFormedY()

float Entity::TFormedY | ( |  | ) |

static

## § TFormedZ()

float Entity::TFormedZ | ( |  | ) |

static

## § TFormNormal()

void Entity::TFormNormal | ( | float | x,
|  | float | y,
|  | float | z,
|  | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

static

## § TFormPoint()

void Entity::TFormPoint | ( | float | x,
|  | float | y,
|  | float | z,
|  | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

static

## § TFormVector()

void Entity::TFormVector | ( | float | x,
|  | float | y,
|  | float | z,
|  | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

static

## § TranslateEntity()

void Entity::TranslateEntity | ( | float | tx,
|  | float | ty,
|  | float | tz,
|  | int | glob = `false`
| ) |  |

## § TurnEntity()

void Entity::TurnEntity | ( | float | x,
|  | float | y,
|  | float | z,
|  | int | glob = `false`
| ) |  |

## § Update()

virtual void Entity::Update | ( |  | ) |

inlinevirtual

Reimplemented in Mesh, ParticleEmitter, Camera, FieldArray, Blob, Light, and Pivot.

## § UpdateAllEntities()

void Entity::UpdateAllEntities | ( | void(Update)(Entity *ent, Entity *ent2) | ,
|  | Entity * | ent2 = `NULL`
| ) |  |

## § UpdateChildren()

void Entity::UpdateChildren | ( | Entity * | ent_p | ) |

static

## § UpdateMat()

void Entity::UpdateMat | ( | bool | load_identity = `false` | ) |

## Member Data Documentation

## § alpha_order

float Entity::alpha_order

## § anim

int Entity::anim

## § anim_dir

int Entity::anim_dir

## § anim_list

int Entity::anim_list

## § anim_mode

int Entity::anim_mode

## § anim_render

int Entity::anim_render

## § anim_seq

int Entity::anim_seq

## § anim_seqs_first

vector<int> Entity::anim_seqs_first

## § anim_seqs_last

vector<int> Entity::anim_seqs_last

## § anim_speed

float Entity::anim_speed

## § anim_time

float Entity::anim_time

## § anim_trans

int Entity::anim_trans

## § anim_update

int Entity::anim_update

## § animate_list

list< Entity * > Entity::animate_list

static

## § box_d

float Entity::box_d

## § box_h

float Entity::box_h

## § box_w

float Entity::box_w

## § box_x

float Entity::box_x

## § box_y

float Entity::box_y

## § box_z

float Entity::box_z

## § brush

Brush Entity::brush

## § child_list

list<Entity*> Entity::child_list

## § class_name

string Entity::class_name

## § collision

vector<CollisionImpact*> Entity::collision

## § collision_type

int Entity::collision_type

## § cull_radius

float Entity::cull_radius

## § dynamic

int Entity::dynamic

## § dynamic_pitch

float Entity::dynamic_pitch

## § dynamic_roll

float Entity::dynamic_roll

## § dynamic_x

float Entity::dynamic_x

## § dynamic_y

float Entity::dynamic_y

## § dynamic_yaw

float Entity::dynamic_yaw

## § dynamic_z

float Entity::dynamic_z

## § entity_list

list< Entity * > Entity::entity_list

static

## § hide

int Entity::hide

## § mat

Matrix Entity::mat

## § name

string Entity::name

## § new_no

int Entity::new_no

## § new_x

float Entity::new_x

## § new_y

float Entity::new_y

## § new_z

float Entity::new_z

## § no_collisions

int Entity::no_collisions

## § no_seqs

int Entity::no_seqs

## § obscurer

int Entity::obscurer

## § old_mat

Matrix Entity::old_mat

## § old_pitch

float Entity::old_pitch

## § old_roll

float Entity::old_roll

## § old_x

float Entity::old_x

## § old_y

float Entity::old_y

## § old_yaw

float Entity::old_yaw

## § old_z

float Entity::old_z

## § order

int Entity::order

## § parent

Entity* Entity::parent

## § pick_mode

int Entity::pick_mode

## § px

float Entity::px

## § py

float Entity::py

## § pz

float Entity::pz

## § qw

float Entity::qw

## § qx

float Entity::qx

## § qy

float Entity::qy

## § qz

float Entity::qz

## § radius_x

float Entity::radius_x

## § radius_y

float Entity::radius_y

## § rotmat

Matrix Entity::rotmat

## § rx

float Entity::rx

## § ry

float Entity::ry

## § rz

float Entity::rz

## § sx

float Entity::sx

## § sy

float Entity::sy

## § sz

float Entity::sz

## § tformed_x

float Entity::tformed_x =0.0

static

## § tformed_y

float Entity::tformed_y =0.0

static

## § tformed_z

float Entity::tformed_z =0.0

static

The documentation for this class was generated from the following files:

- openb3dlib.mod/openb3d/src/entity.h
- openb3dlib.mod/openb3d/src/entity.cpp